* librairie de classes pour l'automation d'OpenOffice 2.0
*  partir de VFP
* Ces classes sont issues de nombreuses contributions en particulier
* celles de Ted ROCHE. 
* Le livre Programmation OpenOffice.org 2 macros et API aux ditions
* Eyrolles auteurs : Bernard MARCILLY et Laurent Godard m'a t d'un
* trs grand secours.
* un remerciement spcial 
*   Bernard MARCILLY, un des auteurs du livre qui m'a dfrich le terrain
*   Cesar CHALOM pour ses liens
*   Olivier HAMOU
*   ...
* les sites suivants sont aussi dignes d'intret :
*  http://www.oooforum.org/forum/viewtopic.phtml?p=28389#28389
*
* dans tout ce qui suit OO veut dire OpenOffice 2

* Ce document comprend d'abord quelques dfinitions, puis une srie de petites
* classes correspondant plus  une structure C qu' une vraie classe (mais elles
* peuvent avoir quelques mthodes) et enfin les classes utilisables par le programmeur.
* Ces classes respectent un peu la hierarchie d'OO : une classe de base contient
* les proprits et les mthodes communes  chaque document OO (c'est vfp_oo); elle
* est sous classe en vfp_oo_writer pour manipuler le traitement de texte; puis, 
* plus tard, en vfp_oo_calc pour manipuler le tableur, ...

* Liste des classes et de leurs mthodes
** Classe: POLICE   base sur Custom
** Classe: PARAGRAPHE   base sur Custom
** Classe: PARAMETRES_IMPRIMANTE   base sur Custom
** Classe: PARAMETRES_IMPRESSION   base sur custom
**
** Classe: VFP_OO   base sur custom
**      162 .init
**      202 .destroy
**      215 .nouveau_document
**      249 .ouvrir_document
**      289 .enregistrer_document
**      315 .enregistrer_copie_document
**      342 .fermer_document
**      366 .imprimer_document
**      421 .informations_document
**      445 .OOoOpenURL
**      475 .OOoPropertyValue
**      495 .OOoCreateStruct
**      520 .OOoConvertToURL
**
** Classe: VFP_OO_WRITER   base sur vfp_oo
**      541 .init
**      549 .destroy
**      561 .nouveau_document_texte
**      599 .ouvrir_document_texte
**      650 .enregistrer_copie_document
**      675 .informations_document
**      689 .debut_texte
**      693 .ajouter_texte
**      697 .nouveau_paragraphe
**
** Classe: VFP_OO_CALC   base sur vfp_oo
**      729 .init
**      738 .destroy
**      750 .nouveau_tableur
**      771 .ouvrir_tableur
**      808 .maj_infos_tableur
**      830 .enregistrer_copie_document
**      855 .informations_document
**      869 .selection_feuille
**      928 .ajouter_feuille
**      965 .cellule_coord_alpha_vers_num
**      992 .cellule_coord_num_vers_alpha
**     1026 .texte_dans_cellule
**     1039 .valeur_dans_cellule
**     1052 .formule_dans_cellule
**     1065 .date_dans_cellule
**     1099 .lire_une_cellule

*OO_automation/sdk/docs/common/ref/com/sun/star/text/ControlCharacter.html
#DEFINE PARAGRAPH_BREAK   0 && nouveau paragraphe
#DEFINE LINE_BREAK        1 && nouvelle ligne dans un paragraphe
#DEFINE HARD_HYPHEN       2 && tiret inscable
#DEFINE SOFT_HYPHEN       3 && tiret conditionnel
#DEFINE HARD_SPACE        4 && espace inscable
#DEFINE APPEND_PARAGRAPH  5 && ajoute un nouveau paragraphe

#DEFINE COLOR_WHITE        16777215
#DEFINE COLOR_BLACK               0

#DEFINE avec_ww .T.   && si cette constante est dfinie, on affiche des messages
  * d'erreur avec WAIT WINDOW. Si vous mettez la ligne en commentaire et que vous
  * recompilez, aucun message n'est affich en cas d'erreur
* ATTENTION : NE METTRE AUCUN CODE EXECUTABLE APRES UN DEFINE CLASS

DEFINE CLASS police AS Custom && jme 04/11/2007
  * paramtres d'une police de caractres
  * je suis oblig de renommer les constantes car dans OO on peut avoir deux constantes
  * de mme nom dans deux fichiers de dclaration diffrents mais pas dans VFP
  
  * OO_automation/sdk/idl/com/sun/star/awt/FontWeight.idl  : graisse des caractres
  #DEFINE GRAISSE_DONTKNOW    0.000000    && graisse par dfaut
  #DEFINE GRAISSE_THIN       50.000000    && caractres fin (moiti de la graisse normale)
  #DEFINE GRAISSE_ULTRALIGHT 60.000000    && caractres ultra fins (60% de la graisse normale) 
  #DEFINE GRAISSE_LIGHT      75.000000    && caractres fins (3/4 de la graisse normale) 
  #DEFINE GRAISSE_SEMILIGHT  90.000000    && 90% de la graisse normale 
  #DEFINE GRAISSE_NORMAL    100.000000    && graisse normale 
  #DEFINE GRAISSE_SEMIBOLD  110.000000    && demi gras (110% de la graisse normale)
  #DEFINE GRAISSE_BOLD      150.000000    && gras 
  #DEFINE GRAISSE_ULTRABOLD 175.000000    && trs gras 
  #DEFINE GRAISSE_BLACK     200.000000    && ultra gras
  
  * OO_automation/sdk/idl/com/sun/star/awt/FontUnderline.idl  : soulignement
  #DEFINE SOULIGN_NONE            0 && pas de soulignement
  #DEFINE SOULIGN_SINGLE          1 && ligne simple
  #DEFINE SOULIGN_DOUBLE          2 && ligne double
  #DEFINE SOULIGN_DOTTED          3 && pointill
  #DEFINE SOULIGN_DONTKNOW        4 && inconnu (??!!??)
  #DEFINE SOULIGN_DASH            5 && tirets
  #DEFINE SOULIGN_LONGDASH        6 && tirets longs
  #DEFINE SOULIGN_DASHDOT         7 && tiret point
  #DEFINE SOULIGN_DASHDOTDOT      8 && tiret point point
  #DEFINE SOULIGN_SMALLWAVE       9 && petite vague
  #DEFINE SOULIGN_WAVE           10 && vague
  #DEFINE SOULIGN_DOUBLEWAVE     11 && double vague
  #DEFINE SOULIGN_BOLD           12 && ligne grasse
  #DEFINE SOULIGN_BOLDDOTTED     13 && points gras
  #DEFINE SOULIGN_BOLDDASH       14 && tirets gras
  #DEFINE SOULIGN_BOLDLONGDASH   15 && long tirets gras
  #DEFINE SOULIGN_BOLDDASHDOT    16 && tiret point gras
  #DEFINE SOULIGN_BOLDDASHDOTDOT 17 && tiret point point en gras
  #DEFINE SOULIGN_BOLDWAVE       18 && vague grasse
  
  * OO_automation/sdk/idl/com/sun/star/awt/FontWidth.idl
  #DEFINE LARGEUR_DONTKNOW         0.000000  && largeur inconnue (par dfaut ?)
  #DEFINE LARGEUR_ULTRACONDENSED  50.000000  && condens (50%)
  #DEFINE LARGEUR_EXTRACONDENSED  60.000000  && condens (60%)
  #DEFINE LARGEUR_CONDENSED       75.000000  && condens (75%)
  #DEFINE LARGEUR_SEMICONDENSED   90.000000  && semi-condens (90%)
  #DEFINE LARGEUR_NORMAL         100.000000  && normal
  #DEFINE LARGEUR_SEMIEXPANDED   110.000000  && semi-expans (110%)
  #DEFINE LARGEUR_EXPANDED       150.000000  && expans (150%)
  #DEFINE LARGEUR_EXTRAEXPANDED  175.000000  && extraexpans (175%)
  #DEFINE LARGEUR_ULTRAEXPANDED  200.000000  && ultra-expans (200%)
 
  * j'ai un problme avec l'italique ! a priori c'est une numration et non
  * des constantes
  * OO_automation/sdk/idl/com/sun/star/awt/Fontslant.idl
*!*  published enum FontSlant
*!*  { 
*!*    /** specifies a font without slant.   */
*!*    NONE, 
*!*    /** specifies an oblique font (slant not designed into the font).   */
*!*    OBLIQUE, 
*!*    /** specifies an italic font (slant designed into the font).   */
*!*    ITALIC, 
*!*    /** specifies a font with an unknown slant.  */
*!*    DONTKNOW, 
*!*    /** specifies a reverse oblique font (slant not designed into the font).  */
*!*    REVERSE_OBLIQUE, 
*!*    /** specifies a reverse italic font (slant designed into the font).   */
*!*    REVERSE_ITALIC 
 
  nom = "Courier New"  && cette police a des caractres de taille fixe; il est donc
  *  trs facile de faire des documents avec des colonnes (facture, ...) alors que si
  *  on utilise une police proportionnelle cela devient un cauchemar.
  taille = 12
  gras = .F.
  italique = .F.
  souligne = .F.
  couleur_texte = color_black
  couleur_fond =  color_white
  
  * il n'y a pas de mthode INIT ni DESTROY dans cette classe
  
  PROCEDURE faire( poquoi)
    * poquoi : curseur sur lequel on doit paramtrer la police
    * on commence par mettre  jour les proprits de cette classe puis
    * on eppelle cette mthode pour les appliquer au curseur qui est pass
    * en paramtre.
    * pour l'instant, je ne sais pas vrifier si l'objet pass est
    * correct. S'il y a un problme, on ne fait rien (sauf faire
    * un wait window si la compilation se fait avec avec_ww = .T.
    
    TRY
      WITH poquoi
        .CharFontName = This.nom
        .CharHeight = This.taille
        .CharColor = This.couleur_texte
        .CharBackColor = This.couleur_fond
        .CharWeight = IIF( This.gras, GRAISSE_BOLD, GRAISSE_NORMAL)
  *!*        .CharPosture = IIF( This.italique, , )
        .FontUnderline = IIF( This.souligne, SOULIGN_SINGLE, SOULIGN_NONE)
      ENDWITH  && poquoi
    CATCH
      #IFDEF avec_ww
      WAIT WINDOW "problme lors du paramtrage de la police" NOWAIT
      #ENDIF
    ENDTRY
  ENDPROC && faire
ENDDEFINE && police

DEFINE CLASS paragraphe AS Custom && jme 04/11/2007
  * paramtres d'un paragraphe
  marge_gauche = 0
  retrait_ligne1 = 0
  marge_droite = 0
  hauteur_avant = 0
  hauteur_apres = 0
ENDDEFINE && paragraphe

DEFINE CLASS parametres_imprimante AS Custom
  marge_haute = 1
  marge_basse = 1
  marge_gauche = 1
  marge_droite = 1
  nom_imprimante = ""
  orientation = 1       && 1 portrait, 2 paysage
ENDDEFINE && parametres_imprimante AS Custom

DEFINE CLASS parametres_impression AS custom
  * cette classe ne contient que des proprits. A priori elle ne peut
  * tre utilise que par la classe VFP_OO et ses descendantes
  nombre_copie = 1
  impression_dans_un_fichier = .F.
  fichier_impression = ""   && par exemple SYS(5)+CURDIR()+ "essai.prn"
  previsualisation = .F.    && non encore utilis
  ordre_des_pages = .T.     && si plusieurs exemplaires : .T. on imprime d'abord
    * le document n 1, puis le document n 2 etc ...  .F. : on imprime toutes les
    * pages 1, puis toutes les pages 2, etc ...
  attente_fin = .T.         && par dfaut on attend que l'impression soit mise dans
    * la file d'attente (le spool) avant de continuer
  pages = ""                && liste des pages  imprimer. Vide si on imprime tout
    * sinon quelque chose comme "3;5;7-11" : impression des pages 3, 5 et de toutes celles
    * comprises entre 7 et 11
*!*    DIMENSION paramimp(5)        && tableau de paramtres pour OO obsolete
ENDDEFINE && parametres_impression AS custom

DEFINE CLASS vfp_oo AS custom
  * cette classe contient les proprits et les mthodes communes  tous les
  * types de document OpenOffice. Elle va tre, ventuellement, sous-classe
  * pour construire les classes correspondant au Writer (traitement de texte),
  *  Calc (feuille de calcul),  Draw (dessin) et  Impress (prsentation)
  
  oo_est_installe = .F.               && .T. si OpenOffice est install
  gestionnaire_de_services = NULL     && pointeur sur le ServiceManager d'OO
  doc = NULL                          && pointeur sur le document OO
  bureau = NULL                       && pointeur sur le 'bureau' d'OO (oo desktop
  fichier_courant = ""                && nom complet du fichier en cours de traitement
  imprimante = NULL                   && pointeur sur la classe parametres_imprimante
  impression = NULL                   && pointeur sur la classe parametres_impression
  cst_paragraph = NULL && essai
    
  abandon_document = .F. && pour les tests : si .T. on ne sauvegarde pas le document dans le destroy
  
  erreur = -1                         && -1 non encore initialis
  *  -2 OO n'est pas installable  -3 chec du createobject,  -4 impossible de crer le bureau
  *  -10  structure UNO impossible  crer, -11 paramtre invalide
  *  -13  impossible de fermer le document
  *  -20  impossible de crer le docuemnt,  -21  impossible de lire le document
  *  -30 et -31 Impossible de crer le pointeur sur le texte
  *  -32  Impossible de crer le curseur d'insertion texte

  PROTECTED PROCEDURE init
    *  l'init on vrifie si openoffice est install
    This.imprimante = NEWOBJECT("parametres_imprimante")
    This.impression = NEWOBJECT("parametres_impression")
    TRY
      This.gestionnaire_de_services = CREATEOBJECT( "com.sun.star.ServiceManager" )
      IF ISNULL(This.gestionnaire_de_services)
        #IFDEF avec_ww
        WAIT WINDOW "erreur instanciation OO" NOWAIT
        #ENDIF
        This.erreur = -3
      ELSE
        This.erreur = 1
      ENDIF && ISNULL(This.gestionnaire_de_services)
    CATCH
      #IFDEF avec_ww
      WAIT WINDOW "Impossible d'instancier OO" NOWAIT
      #ENDIF
      This.erreur = -2
    ENDTRY
    * on va maintenant ouvrir le bureau d'OO
    * note je ne sais pas si on doit avoir un bureau par document
    * ou un bureau par instance d'OO (donc a priori un seul). pour
    * tester je vais en crer qu'un seul donc ici dans l'init
    IF This.erreur = 1
      TRY
        This.bureau = ;
         This.gestionnaire_de_services.createInstance( "com.sun.star.frame.Desktop" )
        COMARRAY( This.bureau, 10 ) &&The array is a zero-based array and is passed by reference
        This.erreur = 2 && ok
      CATCH
        #IFDEF avec_ww
        WAIT WINDOW "impossible d'instancier le bureau OO" NOWAIT
        #ENDIF
        This.bureau = NULL
        This.erreur = -4
      ENDTRY
    ENDIF && This.erreur = 1
  ENDPROC && init
  
  PROTECTED PROCEDURE destroy
    IF !ISNULL(This.doc) AND This.doc.isModified AND This.abandon_document=.F.
      * si on n'a pas de nom de fichier quand on sort, on en crer un automatiquement
      IF EMPTY(This.fichier_courant)
        This.fichier_courant = "OOO_OO_"+ SYS(2015)
      ENDIF && EMPTY(This.fichier_courant)
      This.enregistrer_document()
    ENDIF && This.doc.isModified
    This.doc = NULL
    This.bureau = NULL
    This.gestionnaire_de_services = NULL
  ENDPROC
  
  PROCEDURE nouveau_document( pctypdoc AS String)
    * on cre un nouveau document dont le type est contenu dans pctypdoc
    * nouveau texte : pctypdoc = "private:factory/swriter"
    * nouveau tableur : pctypdoc = "private:factory/scalc"
    * nouveau dessin :  pctypdoc = "private:factory/sdraw"
    * nouvelle prsentation :  pctypdoc = "private:factory/simpress"
    * nouvelles formules mathmatiques :  pctypdoc = "private:factory/smath"
    
    IF This.erreur >=0 AND !EMPTY(m.pctypdoc)
      * on ne cre pas de nouveau document s'il y en a dj un actif
      IF ISNULL(This.doc)
        This.erreur = 0
        This.OOoOpenURL( m.pctypdoc )
        IF ISNULL(This.doc)
          This.erreur = -20
          #IFDEF avec_ww
          WAIT WINDOW "Impossible de crer un nouveau document" NOWAIT
          #ENDIF
        ELSE
          This.erreur = 2 && document ok
          This.abandon_document=.F. && on met .T. quand on ne veut pas que le
          * document soit enregistrer dans le destroy event; il faut donc
          * bien penser  la remettre  faux lors de la cration d'un nouveau
          * document
        ENDIF && ISNULL(This.doc)
      ELSE
        #IFDEF avec_ww
        WAIT WINDOW "Cration nouveau document impossible" + CHR(13)+ ;
         "un autre existe dj" NOWAIT
        #ENDIF
      ENDIF && ISNULL(This.doc)
    ENDIF && This.erreur =2
  ENDPROC
  
  PROCEDURE ouvrir_document( pcfichier AS String)
    * pcfichier est un nom de fichier 00 au format Windows ("c:\toto\tata\tutu.odt")
    LOCAL ARRAY lttab(1)
    LOCAL lcurl
    
    IF This.erreur<2 OR EMPTY(m.pcfichier)
      This.erreur = -11 && paramtre invalide
      #IFDEF avec_ww
      WAIT WINDOW "Il faut indiquer le nom du fichier  ouvrir" NOWAIT
      #ENDIF
    ELSE
      * on demande  VFP de vrifier que le fichier existe bien avant de l'ouvrir
      IF ADIR(lttab, m.pcfichier) > 0
        This.erreur = 0 && on raz l'erreur ventuelle
        This.doc = NULL
        lcurl = This.OOoConvertToURL( m.pcfichier )
        This.OOoOpenURL( m.lcurl )
        IF ISNULL( This.doc)
          This.erreur = -21
          #IFDEF avec_ww
          WAIT WINDOW "Impossible d'ouvrir le fichier" + CHR(13)+ ;
           m.pcfichier NOWAIT
          #ENDIF
        ELSE
          This.erreur = 2 && document ok
          This.abandon_document=.F. && on met .T. quand on ne veut pas que le
          * document soit enregistrer dans le destroy event; il faut donc
          * bien penser  la remettre  faux lors de l'ouverture d'un nouveau
          * document
        ENDIF && ISNULL( This.doc)
      ELSE
        This.erreur = -20
        #IFDEF avec_ww
        WAIT WINDOW "Le fichier" + CHR(13)+ m.pcfichier+ CHR(13)+ ;
         "n'existe pas"NOWAIT
        #ENDIF
      ENDIF && ADIR(lttab, m.pcfichier) > 0
    ENDIF && EMPTY(pcfichier)
  ENDPROC && ouvrir_texte

  PROCEDURE enregistrer_document( pcnomfichier AS String)  && vfp_oo
    * attention, si vous travaillez sur un document TOTO et que vous
    * l'enregistrez sous le nom TATA, vous travaillerez dornavant sur TATA
    * pcnomfichier contient un nom de fichier (avec ventuellement un chemin)
    * au format Windows
    * on ne peut pas exporter en PDF avec storeasurl()
    IF PCOUNT() = 1 AND ! EMPTY(m.pcnomfichier)
      This.fichier_courant = m.pcnomfichier
    ENDIF && PCOUNT() = 1 AND ! EMPTY(m.pcnomfichier)
    * on pourrait tester si le document a t modifi avec la proprit 
    *  This.doc.isModified (cette proprit est en lecture/criture)
    IF EMPTY( JUSTPATH(This.fichier_courant))
      * on ne peut pas sauvegarder un document SANS lui donner le chemin complet !
      This.fichier_courant = SYS(5)+ CURDIR()+ This.fichier_courant
    ENDIF && EMPTY( JUSTPATH(This.fichier_courant))
    LOCAL lcurl, lcext
    LOCAL ARRAY lcparam(1)
    lcext = JUSTEXT(This.fichier_courant)
    * on veut prvenir l'oprateur s'il crase une version prcdente du document
    * (mme si c'est le mme fichier; si c'est trop perturbant on peut supprimer
    *  cette option ou effacer le fichier destinataire avant de faire l'enregistrement)
    lcparam(1) = This.OOoPropertyValue( "Overwrite", .F. )
    lcurl = This.OOoConvertToURL( m.pcnomfichier )
    This.doc.storeAsURL( m.lcurl, @ lcparam)
  ENDPROC && enregistrer_document
  
  PROCEDURE enregistrer_copie_document( pcnomfichier AS String)
    * on veut crer une copie du document courant (on cre un fichier
    * sur le disque mais on continue de travailler sur le document courant)
    * pcnomfichier contient un nom de fichier (avec ventuellement un chemin)
    * au format Windows
    * attention la mthode storeToURL est diffrente de storeAsURL
    * avec cette mthode on pourrait exporter en PDF, mais, comme les paramtres
    * dpendent du type de document, on va faire une mthode hrite dans
    * vfp_oo_writer pour un document texte et dans vfp_oo_calc pour une feuille de calcul.
    IF PCOUNT() = 1 AND ! EMPTY(m.pcnomfichier)
*!*        IF This.fichier_courant <> m.pcnomfichier  jme 18/11/2007 test annul
      IF EMPTY( JUSTPATH(m.pcnomfichier))
        * on ne peut pas sauvegarder un document SANS lui donner le chemin complet !
        pcnomfichier = SYS(5)+ CURDIR()+ m.pcnomfichier
      ENDIF && EMPTY( JUSTPATH(m.pcnomfichier))
      LOCAL lcurl
      LOCAL ARRAY lcparam(1)
      * on veut prvenir l'oprateur s'il crase une version prcdente du document
      * (mme si c'est le mme fichier; si c'est trop perturbant on peut supprimer
      *  cette option)
      lcparam(1) = This.OOoPropertyValue( "Overwrite", .T. )
      lcurl = This.OOoConvertToURL( m.pcnomfichier )
      This.doc.storeToURL( m.lcurl, @ lcparam)
*!*        ENDIF && This.fichier_courant <> m.pcnomfichier
    ENDIF && PCOUNT() = 1 AND ! EMPTY(m.pcnomfichier)
  ENDPROC && enregistrer_document
  
  PROCEDURE fermer_document
    LOCAL llok
    
    llok = .T.
    IF This.doc.isModified
      llok = IIF( INLIST( MESSAGEBOX("Le document" + CHR(13)+ This.fichier_courant + ;
       CHR(13)+ "n'a pas t enregistr." + CHR(13)+ "Voulez-vous l'enregistrer ?", ;
        4+32, "ATTENTION", 60000), -1,6), .T., .F.)
    ENDIF && This.doc.isModified
    IF m.llok = .T.
      TRY
        This.doc.close(.T.)
        This.abandon_document=.T. && on ne veut pas enregistrer dans le destroy
        This.doc = NULL
        This.erreur = 1
      CATCH
        This.erreur = -13 && impossible de fermer le document
        #IFDEF avec_ww
        WAIT WINDOW "Impossible de fermer le document" NOWAIT
        #ENDIF
      ENDTRY
    ENDIF && m.llok = .T.
  ENDPROC && fermer_document()
  
  PROCEDURE imprimer_document
    * ATTENTION : il faut normalement 5 paramtres pour piloter l'impression. Ces
    * 5 paramtres sont mmoriss dans l'instance de parametres_impression pointe
    * par This.impression. Lorsqu'un paramtre est vide (comme filename si on
    * imprime sur l'imprimante ou pages si on veut tout imprimer), il ne doit PAS
    * tre transmis. La dimension du tableau transmis  OO est donc variable et
    * dpend du nombre de paramtres utiles.
    
*!*      ci dessous un bout de code pour imprimer les proprits de printer et leur valeur    
*!*      loprinter = This.doc.printer
*!*      lnaccu = ALEN(loprinter)
*!*      SET TEXTMERGE TO essai_printer.txt ADDITIVE NOSHOW
*!*      SET TEXTMERGE ON
*!*      \<<DATE()>> <<TIME()>>
*!*      lcaccu = ""
*!*      FOR m.lni = 1 TO m.lnaccu
*!*         *lcaccu = m.lcaccu+loprinter(m.lni).name+ CHR(13)
*!*         IF VARTYPE(loprinter(m.lni).value) <> "O"
*!*           \  <<loprinter(m.lni).name>> : <<loprinter(m.lni).value>>
*!*         ELSE
*!*           \  <<loprinter(m.lni).name>> : objet
*!*         ENDIF && VARTYPE(loprinter(m.lni).value) <> "O"
*!*      ENDFOR &&* m.lni = 1 TO m.lnaccu
*!*      SET TEXTMERGE OFF
*!*      SET TEXTMERGE TO
    
    WITH This.impression
      DO CASE
      CASE .impression_dans_un_fichier AND EMPTY(.pages)
        * impression de tout le document dans un fichier
        LOCAL ARRAY loparam(4)
        loparam(4) = This.OOoPropertyValue( "FileName", .fichier_impression)
      CASE .impression_dans_un_fichier AND !EMPTY(.pages)
        * impression d'une liste de pages du document dans un fichier
        LOCAL ARRAY loparam(5)
        loparam(5) = This.OOoPropertyValue( "FileName", .fichier_impression)
        loparam(4) = This.OOoPropertyValue( "Pages", .pages)
      CASE !.impression_dans_un_fichier AND EMPTY(.pages)
        * impression de tout le document sur l'imprimante
        LOCAL ARRAY loparam(3)
      CASE !.impression_dans_un_fichier AND !EMPTY(.pages)
        * impression d'une liste de pages du document sur l'imprimante
        LOCAL ARRAY loparam(4)
        loparam(4) = This.OOoPropertyValue( "Pages", .pages)
      ENDCASE
      loparam(1) = This.OOoPropertyValue( "CopyCount", .nombre_copie) && faut expliquer ?
      * Collate : si plusieurs exemplaires : .T. on imprime d'abord le document n 1, 
      * puis le document n 2 etc ...  .F. : on imprime toutes les pages 1, puis toutes 
      * les pages 2, etc ...
      loparam(2) = This.OOoPropertyValue( "Collate", .ordre_des_pages)
      loparam(3) = This.OOoPropertyValue( "Wait", .attente_fin)
    ENDWITH  && This.impression
    This.doc.Print( @loparam)
  ENDPROC && imprimer_document
  
  PROCEDURE informations_document
    LOCAL lcfichier, loinfos, lodate
    IF !ISNULL(This.doc)
      lcfichier = This.doc.location
      loinfos = This.doc.documentInfo
      lodate = loinfos.CreationDate
      = MESSAGEBOX("document :"+ m.lcfichier+ CHR(13)+ ;
       "auteur: "+ m.loinfos.Author+ CHR(13)+ ;
       "cration: "+ STR(m.lodate.Day,2)+"/"+ TRANSFORM(m.lodate.Month, "@L 99")+ ;
        "/"+ STR(m.lodate.Year,4)+ CHR(13), 0, "informations")
    ENDIF && !ISNULL(This.doc)
  ENDPROC && informations_document
  
*********************************************************  
* ci-dessous : toutes les mthodes 'utilitaires'
*********************************************************
  * ben, pour l'instant, il y en a plus !!

*********************************************************  
* ci-dessous : toutes les mthodes OO utilises ci-dessus
*********************************************************
* HIDDEN : la mthode ne peut tre appele que depuis cette classe. Mme
*          les sous-classes de vfp_oo ne peuvent pas y accder.

  PROTECTED PROCEDURE OOoOpenURL( pcURL )
    * Ouvre ou cre un document  partir de son URL.
    * Pour crer un nouveau document, l'URL est :
    *  private:factory/sdraw  pour un nouveau document de dessin
    *  private:factory/swriter pour un nouveau document texte
    *  private:factory/scalc  pour un nouveau classeur de feuilles de calcul
    *  private:factory/simpress && pour un nouveau document de prsentation

*!*        *  LOCAL oPropertyValue
*!*        *  oPropertyValue = OOoCreateStruct( "com.sun.star.beans.PropertyValue" )
*!*        *  LOCAL ARRAY aNoArgs[1]
*!*        *  aNoArgs[1] = oPropertyValue
*!*        *  aNoArgs[1].Name = "ReadOnly"
*!*        *  aNoArgs[1].Value = .F.
*!*        * These two lines replace the alternate version above,
*!*        *  which are left commented for the insight they provide.
    LOCAL ARRAY aNoArgs[1]
    * grossirement : on cre une structure contenant la proprit 'hidden'
    *  initialise  .F. et dont l'adresse est dans le premier lment de anoargs
    aNoArgs[1] = This.OOoPropertyValue( "Hidden", .F. )
    This.doc = This.bureau.LoadComponentFromUrl( m.pcURL, "_blank", 0, @aNoargs )
    * Make sure that arrays passed to this document are passed zero based and through
    * reference
    * COMARRAY indique  VFP que tous les tableaux passs  this.doc doivent tre
    * bass sur 0 (le premier lment a pour indice 0 et non 1) et tre passs par
    * rfrence. Toutefois, malgr cette instruction (bug ?) les tableaux doivent tre
    * prcds par @ si on veut que VFP les passe par rfrence.
    COMARRAY( This.doc, 10 )
  ENDPROC
  
  FUNCTION OOoPropertyValue( cName, uValue, nHandle, nState )
    * Create a com.sun.star.beans.PropertyValue struct and return it.
    * crer une structure du type com.sun.star.beans.PropertyValue et
    * retourne un pointeur
    * la structure utilise par OO ne peut pas tre cre directement en VFP
    * on va donc demander  OO de la crer pour nous
    LOCAL oPropertyValue
    oPropertyValue = This.OOoCreateStruct( "com.sun.star.beans.PropertyValue" )
    oPropertyValue.Name = m.cName
    oPropertyValue.Value = m.uValue
    * si on a des paramtres supplmentaires, on les traite
    IF TYPE([nHandle])="N"
      oPropertyValue.Handle = m.nHandle
    ENDIF
    IF TYPE([nState])="N"
      oPropertyValue.State = m.nState
    ENDIF
    RETURN m.oPropertyValue
  ENDFUNC

  FUNCTION OOoCreateStruct( cTypeName AS String)
    * fonction pour crer n'importe quel type de structure UNO
    * on l'a fait crer par OO
    LOCAL oStruct
    oStruct = .NULL.
    TRY
      oStruct = This.gestionnaire_de_services.Bridge_GetStruct( m.cTypeName )
    CATCH
      WAIT WINDOW "impossible de crer la structure" TIMEOUT 2
      oStruct = NULL
      This.erreur = -10 && structure UNO impossible  crer
    ENDTRY
    * dans les exemples lus, il semble qu'il pouvait y avoir un problme si certaines
    * variables globales taient dj mises  jour. Pour l'instant, je supprime
    * cette partie
*!*      IF ISNULL( m.oStruct )
*!*        * on n'a pas russi  crer la structure, on essaie de corriger un problme
*!*        * et de recommencer
*!*        =__OOoReleaseCachedVars()
*!*        oServiceManager = OOoGetServiceManager()
*!*        oStruct = oServiceManager.Bridge_GetStruct( cTypeName )
*!*      ENDIF && ISNULL( m.oStruct )
    RETURN m.oStruct
  ENDFUNC && OOoCreateStruct( cTypeName )

  FUNCTION OOoConvertToURL( cFilename AS String)
    * convertit un nom de fichier Windows en un nom OO
    * le nom doit commencer par "/" et il faut changer les \ en /
    RETURN "file://" + IIF(ASC(m.cFilename)=47, "", "/")+ ;
     CHRTRAN( m.cFilename, "\", "/" )
  ENDFUNC
  
ENDDEFINE && vfp_oo


DEFINE CLASS vfp_oo_writer AS vfp_oo && jme 04/11/2007
  * cette classe contient les proprits et les mthodes propres au
  * document Writer (traitement de texte) d'openOffice
  
  texte = NULL                        && pointeur sur le texte du document
  cuecr = NULL                        && curseur criture
  cureel = NULL                       && curseur visible (le clignotant)
*  erreur = -1                         && -1 non encore initialis
  *  -30 et -31 Impossible de crer le pointeur sur le texte
  *  -32  Impossible de crer le curseur d'insertion texte

  PROTECTED PROCEDURE init
    *  l'init on vrifie si openoffice est install
    DODEFAULT()
    IF This.erreur = 2
      * initialisation propre au Writer
    ENDIF && This.erreur = 2
  ENDPROC && init
  
  PROTECTED PROCEDURE destroy
    IF !ISNULL(This.doc) AND This.doc.isModified AND This.abandon_document=.F.
      * si on n'a pas de nom de fichier quand on sort, on en crer un automatiquement
      IF EMPTY(This.fichier_courant)
        This.fichier_courant = "OOO_WRITER_"+ SYS(2015)
      ENDIF && EMPTY(This.fichier_courant)
      This.enregistrer_document()
    ENDIF && This.doc.isModified
    This.doc = NULL
    DODEFAULT()
  ENDPROC
  
  PROCEDURE nouveau_document_texte
    * on cre un nouveau document texte
    IF This.erreur =2
      * on ne cre pas de nouveau document s'il y en a dj un actif
      IF ISNULL(This.doc)
        This.nouveau_document( "private:factory/swriter" )
        IF ISNULL(This.doc)
          * il n'y a rien  faire ici, l'erreur a dj t donne
        ELSE
          This.texte = This.doc.Text && pointeur sur le texte du document
          * note le texte est le contenu du document. D'autres pointeurs 
          * existent pour l'en-tte, le pied de page, etc ....
          IF ISNULL(This.texte)
            This.erreur = -30
            #IFDEF avec_ww
            WAIT WINDOW "Impossible de crer le pointeur sur le texte" NOWAIT
            #ENDIF
          ELSE
            This.cuecr = This.texte.createTextCursor()
            IF ISNULL(This.cuecr)
              This.erreur = -32
              #IFDEF avec_ww
              WAIT WINDOW "Impossible de crer le curseur d'insertion texte" NOWAIT
              #ENDIF
            ELSE
              This.erreur = 2 && tout va bien
            ENDIF && ISNULL(This.cuecr)
          ENDIF && ISNULL(This.texte)
        ENDIF && ISNULL(This.doc)
      ELSE
        #IFDEF avec_ww
        WAIT WINDOW "Cration nouveau document impossible" + CHR(13)+ ;
         "un autre existe dj" NOWAIT
        #ENDIF
      ENDIF && ISNULL(This.doc)
    ENDIF && This.erreur =2
  ENDPROC
  
  PROCEDURE ouvrir_document_texte( pcfichier AS String)
    * pcfichier est un nom de fichier document text au format Windows
    LOCAL ARRAY lttab(1)
    LOCAL lcurl
    
    IF EMPTY(m.pcfichier)
      This.erreur = -11 && paramtre invalide
      WAIT WINDOW "Il faut indiquer le nom du fichier  ouvrir" NOWAIT
    ELSE
      IF ADIR(lttab, m.pcfichier) > 0
        This.erreur = 0 && on raz l'erreur ventuelle
        This.doc = NULL
        lcurl = This.OOoConvertToURL( m.pcfichier )
        This.OOoOpenURL( m.lcurl )
        IF ISNULL( This.doc)
          This.erreur = -21
          #IFDEF avec_ww
          WAIT WINDOW "Impossible d'ouvrir le fichier" + CHR(13)+ ;
           m.pcfichier NOWAIT
          #ENDIF
        ELSE
          This.texte = This.doc.Text && pointeur sur le texte du document
          * note le texte est le contenu du document. D'autres pointeurs 
          * existent pour l'en-tte, le pied de page, etc ....
          IF ISNULL(This.texte)
            This.erreur = -31
            #IFDEF avec_ww
            WAIT WINDOW "Impossible de crer le pointeur sur le texte" NOWAIT
            #ENDIF
          ELSE
            This.cuecr = This.texte.createTextCursor()
            IF ISNULL(This.cuecr)
              This.erreur = -32
              #IFDEF avec_ww
              WAIT WINDOW "Impossible de crer le curseur d'insertion texte" NOWAIT
              #ENDIF
            ELSE
              This.erreur = 2 && tout va bien
            ENDIF && ISNULL(This.cuecr)
          ENDIF && ISNULL(This.texte)
        ENDIF && ISNULL( This.doc)
      ELSE
        This.erreur = -20
        #IFDEF avec_ww
        WAIT WINDOW "Le fichier" + CHR(13)+ m.pcfichier+ CHR(13)+ ;
         "n'existe pas"NOWAIT
        #ENDIF
      ENDIF && ADIR(lttab, m.pcfichier) > 0
    ENDIF && EMPTY(pcfichier)
  ENDPROC && ouvrir_texte
  
  PROCEDURE enregistrer_copie_document( pcnomfichier AS String)  && vfp_oo_writer
    * on veut crer une copie du document texte courant (on cre un fichier
    * sur le disque mais on continue de travailler sur le document courant)
    * pcnomfichier contient un nom de fichier (avec ventuellement un chemin)
    * au format Windows
    * on va crer systmatiquement un export  PDF
    IF PCOUNT() = 1 AND ! EMPTY(m.pcnomfichier)
      IF EMPTY( JUSTPATH(m.pcnomfichier))
        * on ne peut pas sauvegarder un document SANS lui donner le chemin complet !
        pcnomfichier = SYS(5)+ CURDIR()+ m.pcnomfichier
      ENDIF && EMPTY( JUSTPATH(m.pcnomfichier))
      DODEFAULT( m.pcnomfichier)
      LOCAL lcurl
      LOCAL ARRAY lcparam(2)
      * on veut prvenir l'oprateur s'il crase une version prcdente du document
      * (mme si c'est le mme fichier; si c'est trop perturbant on peut supprimer
      *  cette option ou supprimer le PDF avant de lancer cette mthode)
      lcparam(2) = This.OOoPropertyValue( "Overwrite", .T. )
      lcparam(1) = This.OOoPropertyValue( "FilterName", "writer_pdf_Export")
      * il faut enlever l'ventuelle extension du nom du fichier pour la remplacer par .pdf
      lcurl = This.OOoConvertToURL( JUSTPATH(m.pcnomfichier)+ "\"+ JUSTSTEM(m.pcnomfichier)+ ".pdf")
      This.doc.storeToURL( m.lcurl, @ lcparam)
    ENDIF && PCOUNT() = 1 AND ! EMPTY(m.pcnomfichier)
  ENDPROC && enregistrer_document
  
  PROCEDURE informations_document
    LOCAL lcfichier, loinfos, lodate
    IF !ISNULL(This.doc)
      lcfichier = This.doc.location
      loinfos = This.doc.documentInfo
      lodate = loinfos.CreationDate
      = MESSAGEBOX("document :"+ m.lcfichier+ CHR(13)+ ;
       "auteur: "+ m.loinfos.Author+ CHR(13)+ ;
       "cration: "+ STR(m.lodate.Day,2)+"/"+ TRANSFORM(m.lodate.Month, "@L 99")+ ;
        "/"+ STR(m.lodate.Year,4)+ CHR(13)+ ;
       "nombre de mots: "+ ALLTRIM(STR(This.doc.WordCount,6)), 0, "informations")
    ENDIF && !ISNULL(This.doc)
  ENDPROC && informations_document
  
  PROCEDURE debut_texte
    This.cuecr.gotoStart(.F.)
  ENDPROC
  
  PROCEDURE ajouter_texte( pctexte AS String)
    This.texte.insertString( This.cuecr, m.pctexte, .F.)
  ENDPROC && ajouter_texte
  
  PROCEDURE nouveau_paragraphe && insertion d'un nouveau paragraphe
    *  l'endroit du curseur d'criture
    * "com.sun.star.text.ControlCharacter.PARAGRAPH_BREAK"
    This.texte.insertControlCharacter(This.cuecr, PARAGRAPH_BREAK, .F.)
  ENDPROC && nouveau_paragraphe
  
ENDDEFINE && vfp_oo_writer


DEFINE CLASS vfp_oo_calc AS vfp_oo && jme 07/11/2007
  * cette classe contient les proprits et les mthodes propres au
  * document Writer (traitement de texte) d'openOffice
  
  nombre_feuilles = 0       && nombre de feuilles
  DIMENSION feuilles(1,3)   && tableau contenant les noms des feuilles (col 1),
    * leur ordre de cration (colonne 2) et leur position (colonne 3) (les valeurs
    * pour l'ordre et la position commencent  0 et non 1)
    * la 2me feuille cre peut bien tre dplace  la 5me position par exemple.
  feuille_active = 0        && ordre de la feuille active
  coord_cellule_alpha = ""  && coordones d'une cellule au format "A5" ou "BA15"
  DIMENSION coord_cellule(2)  && 1: numro de la ligne o est la cellule (  partir de 0);
    * 2: numro de la colonne o est la cellule (  partir de 0)
  une_cellule = NULL        && pointeur sur une structure reprsentant une cellule
  une_cellule_valeur = 0    && valeur numrique d'une cellule
  une_cellule_texte = ""    && texte contenu dans une cellule
  une_cellule_formule = ""  && formule contenue dans une cellule
  une_cellule_date = {}     && date contenue dans une cellule
  coord_region_alpha = ""   && coordonnes d'une rgion au format "A5:Z10"
  DIMENSION coord_region(4)  && 1: ligne du coin en haut  gauche, 2 colonne de ce coin;
    * 3 ligne du coin en bas  droite, 4 colonne de ce coin
  

  PROTECTED PROCEDURE init
    *  l'init on vrifie si openoffice est install
    DODEFAULT()
    IF This.erreur = 2
      * initialisation propre  Calc
      STORE 0 TO This.coord_cellule, This.coord_region
    ENDIF && This.erreur = 2
  ENDPROC && init
  
  PROTECTED PROCEDURE destroy
    IF !ISNULL(This.doc) AND This.doc.isModified AND This.abandon_document=.F.
      * si on n'a pas de nom de fichier quand on sort, on en crer un automatiquement
      IF EMPTY(This.fichier_courant)
        This.fichier_courant = "OOO_CALC_"+ SYS(2015)
      ENDIF && EMPTY(This.fichier_courant)
      This.enregistrer_document()
    ENDIF && This.doc.isModified
    This.doc = NULL
    DODEFAULT()
  ENDPROC
  
  PROCEDURE nouveau_tableur
    * on cre un nouveau document de calcul
    IF This.erreur =2
      * on ne cre pas de nouveau document s'il y en a dj un actif
      IF ISNULL(This.doc)
        This.nouveau_document( "private:factory/scalc" )
        IF ISNULL(This.doc)
          * il n'y a rien  faire ici, l'erreur a dj t donne
        ELSE
          This.maj_infos_tableur()
          This.erreur = 2 && ok
        ENDIF && ISNULL(This.doc)
      ELSE
        #IFDEF avec_ww
        WAIT WINDOW "Cration nouveau document impossible" + CHR(13)+ ;
         "un autre existe dj" NOWAIT
        #ENDIF
      ENDIF && ISNULL(This.doc)
    ENDIF && This.erreur =2
  ENDPROC
  
  PROCEDURE ouvrir_tableur( pcfichier AS String)
    * pcfichier est un nom de fichier document Calc (au format Windows)
    LOCAL ARRAY lttab(1)
    LOCAL lcurl
    
    IF EMPTY(m.pcfichier)
      This.erreur = -11 && paramtre invalide
      WAIT WINDOW "Il faut indiquer le nom du fichier  ouvrir" NOWAIT
    ELSE
      * on demande  VFP de vrifier l'existence du fichier (c'est pour faciliter
      * la gestion de l'erreur, je ne sais pas ce que fait OO si le fichier 
      * n'existe pas)
      IF ADIR(lttab, m.pcfichier) > 0
        This.erreur = 0 && on raz l'erreur ventuelle
        This.doc = NULL
        lcurl = This.OOoConvertToURL( m.pcfichier )
        This.OOoOpenURL( m.lcurl )
        IF ISNULL( This.doc)
          This.erreur = -21
          #IFDEF avec_ww
          WAIT WINDOW "Impossible d'ouvrir le fichier" + CHR(13)+ ;
           m.pcfichier NOWAIT
          #ENDIF
        ELSE
          This.maj_infos_tableur()
          This.erreur = 2 && ok
        ENDIF && ISNULL( This.doc)
      ELSE
        This.erreur = -20
        #IFDEF avec_ww
        WAIT WINDOW "Le fichier" + CHR(13)+ m.pcfichier+ CHR(13)+ ;
         "n'existe pas"NOWAIT
        #ENDIF
      ENDIF && ADIR(lttab, m.pcfichier) > 0
    ENDIF && EMPTY(pcfichier)
  ENDPROC && ouvrir_texte
  
  PROTECTED PROCEDURE maj_infos_tableur
    * met  jour les proprits nombre_feuilles, et feuilles avec
    * le nombre de feuilles leurs nom, position et ordre
    LOCAL lnaccu, lni, lnmax, lo1feuille

    STORE This.doc.Sheets.Count TO This.nombre_feuilles, lnaccu
    DIMENSION This.feuilles(m.lnaccu,3)
    lnmax = m.lnaccu -1
    FOR m.lni = 0 TO m.lnmax
      lnaccu = m.lni + 1
      * lo1feuille = This.doc.Sheets( m.lni)
      lo1feuille = This.doc.getSheets().getByIndex( m.lni )
      This.feuilles( m.lnaccu, 1) = lo1feuille.Name && nom de la feuille
      This.feuilles( m.lnaccu, 2) = m.lnaccu
      * la troisime feuille cre a pu tre dplace  la 1re position par
      * l'oprateur; la 3me colonne du tableau contient donc la position de 
      * la feuille et non son ordre de cration.
      This.feuilles( m.lnaccu, 3) = lo1feuille.getRangeAddress().Sheet
    ENDFOR &&* m.lni = 0 TO m.lnmax
    This.feuille_active = This.doc.currentController.activeSheet
  ENDPROC && maj_infos_tableur

  PROCEDURE enregistrer_copie_document( pcnomfichier AS String)  && vfp_oo_calc
    * on veut crer une copie du tableur courant (on cre un fichier
    * sur le disque mais on continue de travailler sur le document courant)
    * pcnomfichier contient un nom de fichier (avec ventuellement un chemin)
    * au format Windows
    * on va crer systmatiquement un export PDF
    IF PCOUNT() = 1 AND ! EMPTY(m.pcnomfichier)
      IF EMPTY( JUSTPATH(m.pcnomfichier))
        * on ne peut pas sauvegarder un document SANS lui donner le chemin complet !
        pcnomfichier = SYS(5)+ CURDIR()+ m.pcnomfichier
      ENDIF && EMPTY( JUSTPATH(m.pcnomfichier))
      DODEFAULT( m.pcnomfichier)
      LOCAL lcurl
      LOCAL ARRAY lcparam(2)
      * on veut prvenir l'oprateur s'il crase une version prcdente du document
      * (mme si c'est le mme fichier; si c'est trop perturbant on peut supprimer
      *  cette option ou supprimer le PDF avant de lancer cette mthode)
      lcparam(2) = This.OOoPropertyValue( "Overwrite", .T. )
      lcparam(1) = This.OOoPropertyValue( "FilterName", "calc_pdf_Export")
      * il faut enlever l'ventuelle extension du nom du fichier pour la remplacer par .pdf
      lcurl = This.OOoConvertToURL( JUSTPATH(m.pcnomfichier)+ "\"+ JUSTSTEM(m.pcnomfichier)+ ".pdf")
      This.doc.storeToURL( m.lcurl, @ lcparam)
    ENDIF && PCOUNT() = 1 AND ! EMPTY(m.pcnomfichier)
  ENDPROC && enregistrer_document
  
  PROCEDURE informations_document
    LOCAL lcfichier, loinfos, lodate
    IF !ISNULL(This.doc)
      lcfichier = This.doc.location
      loinfos = This.doc.documentInfo
      lodate = loinfos.CreationDate
      = MESSAGEBOX("document :"+ m.lcfichier+ CHR(13)+ ;
       "auteur: "+ m.loinfos.Author+ CHR(13)+ ;
       "cration: "+ STR(m.lodate.Day,2)+"/"+ TRANSFORM(m.lodate.Month, "@L 99")+ ;
        "/"+ STR(m.lodate.Year,4)+ CHR(13)+ ;
       "nombre de feuilles: "+ ALLTRIM(STR(This.nombre_feuilles,6)), 0, "informations")
    ENDIF && !ISNULL(This.doc)
  ENDPROC && informations_document

  PROCEDURE selection_feuille(luparametre)
    * si luparametre est une chane de caractres, on recherche la feuille qui porte
    * ce nom. Si c'est une valeur numrique, on cherche la feuille de ce rang (ordre
    * visible commenant  1 et non ordre de cration)
    *  oSheet = oDoc.getSheets().getByIndex( 0 ) ' get the zero'th sheet
    *  oSheet = oDoc.getSheets().getByName( "Sheet3" ) ' get by name

    IF PCOUNT() > 0
      IF VARTYPE(m.luparametre)=="C" AND !EMPTY(m.luparametre)
        * on cherche le feuille qui porte le nom pass en paramtre
        IF This.doc.getSheets().hasByName( m.luparametre)
          This.feuille_active = NULL
          This.feuille_active = This.doc.getSheets().getByName( m.luparametre )
          IF ISNULL(This.feuille_active)
            #IFDEF avec_ww
            WAIT WINDOW "La feuille" + CHR(13)+ m.luparametre+ CHR(13)+ ;
             "est impossible  atteindre" NOWAIT
            #ENDIF
          ELSE
            This.doc.currentController.activeSheet = This.feuille_active
          ENDIF && ISNULL(This.feuille_active)
        ELSE
          #IFDEF avec_ww
          WAIT WINDOW "La feuille" + CHR(13)+ m.luparametre+ CHR(13)+ ;
           "n'existe pas" NOWAIT
          #ENDIF
        ENDIF && This.doc.getSheets().hasByName( "Sheet3" )
      ELSE
        IF VARTYPE(m.luparametre)=="N" OR VARTYPE(m.luparametre)=="I"
          IF BETWEEN(m.luparametre, 1, This.nombre_feuilles)
            This.feuille_active = NULL
            This.feuille_active = This.doc.getSheets().getByIndex( m.luparametre -1)
            IF ISNULL(This.feuille_active)
              #IFDEF avec_ww
              WAIT WINDOW "La feuille n " + STR(m.luparametre)+ CHR(13)+ ;
               "est impossible  atteindre" NOWAIT
              #ENDIF
            ELSE
              This.doc.currentController.activeSheet = This.feuille_active
            ENDIF && ISNULL(This.feuille_active)
          ELSE
            #IFDEF avec_ww
            WAIT WINDOW "numro de feuille hors limites" NOWAIT
            #ENDIF
          ENDIF && BETWEEN(m.luparametre, 1, This.nombre_feuilles)
        ELSE
          #IFDEF avec_ww
          WAIT WINDOW "paramtre incorrect" NOWAIT
          #ENDIF
        ENDIF && VARTYPE(m.luparametre)=="N"
      ENDIF && VARTYPE(m.luparametre)=="C"
    ELSE
      #IFDEF avec_ww
      WAIT WINDOW "Il me faut le nom de la feuille" + CHR(13)+ ;
       "ou son numro d'ordre" NOWAIT
      #ENDIF
    ENDIF && PCOUNT() > 0
  ENDPROC && selection_feuille
  
  PROCEDURE ajouter_feuille( lnposition AS Number, lcnom AS String)
    * On ajoute la feuille de nom lcnom  la position lnposition.
    * lnposition compris entre 1 (et non 0) et This.nombre_feuilles + 1
    * NOTE : je met beaucoup de tests mais c'est pour faciliter le dboguage
    IF PCOUNT()=2 AND BETWEEN(m.lnposition, 1, This.nombre_feuilles+1) AND ;
     !EMPTY(m.lcnom)
      IF This.doc.getSheets().hasByName( m.lcnom)
        * une feuille porte dj ce nom
        #IFDEF avec_ww
        WAIT WINDOW "Une feuille porte dj le nom" + CHR(13)+ m.lcnom NOWAIT
        #ENDIF
      ELSE
        LOCAL lofeuille
        lofeuille = This.feuille_active
        This.feuille_active = NULL
        This.doc.getSheets().insertNewByName(m.lcnom, m.lnposition-1)
        IF This.doc.getSheets().hasByName( m.lcnom)
          This.feuille_active = This.doc.getSheets().getByName( m.lcnom)
          IF ISNULL( This.feuille_active)
            This.feuille_active = m.lofeuille
          ENDIF && ISNULL( This.feuille_active)
        ELSE
          This.feuille_active = m.lofeuille
        ENDIF && This.doc.getSheets().hasByName( m.lcnom)
        This.doc.currentController.activeSheet = This.feuille_active
      ENDIF && This.doc.getSheets().hasByName( m.lcnom)
    ELSE
      #IFDEF avec_ww
      WAIT WINDOW "Au moins un paramtre incorrect" NOWAIT
      #ENDIF
    ENDIF && PCOUNT()=2 AND BETWEEN(m.lnposition, 1, This.nombre_feuilles+1) AND
  ENDPROC && ajouter_feuille
  
*!*    coord_cellule_alpha = ""  && coordones d'une cellule au format "A5" ou "BA15"
*!*    DIMENSION coord_cellule(2)  && 1: numro de la ligne o est la cellule (  partir de 0);
*!*      * 2: numro de la colonne o est la cellule (  partir de 0)
  
  PROCEDURE cellule_coord_alpha_vers_num( m.lccoord AS String)
    * dans OO.Calc, une cellule peut tre accde par deux types de coordonnes quivalentes :
    * le texte "A1" ou "AA5" ou par ses numros de ligne/ numros de colonne.
    * "A1" quivaut  0,0
    IF PCOUNT()=1 AND !EMPTY(m.lccoord)
      This.coord_cellule_alpha = ALLTRIM(m.lccoord)
    ENDIF && PCOUNT()=1 AND !EMPTY(m.lccoord)
    LOCAL lnligne, lnaccu, lncolonne, lccar, lnlong
    STORE 0 TO lncolonne, lnligne
    lnaccu = 1
    lnlong = LEN(This.coord_cellule_alpha)
    lccar = LEFT(This.coord_cellule_alpha,1)
    DO WHILE ISALPHA(m.lccar)
      lncolonne = m.lncolonne * 26 + (ASC(m.lccar)-64)
      lnaccu = m.lnaccu + 1
      lccar = IIF(m.lnaccu<=m.lnlong, SUBSTR( This.coord_cellule_alpha, m.lnaccu,1), "")
    ENDDO && ISALPHA(SUBSTR( This.coord_cellule_alpha, m.lnaccu,1))
    * normalement, lccar contient le premier chiffre
    DO WHILE ISDIGIT(m.lccar)
      lnligne = m.lnligne * 10 + (ASC(m.lccar)-48)
      lnaccu = m.lnaccu + 1
      lccar = IIF(m.lnaccu<=m.lnlong, SUBSTR( This.coord_cellule_alpha, m.lnaccu,1), "")
    ENDDO && ISALPHA(SUBSTR( This.coord_cellule_alpha, m.lnaccu,1))
    This.coord_cellule(1)= m.lnligne - 1
    This.coord_cellule(2)= m.lncolonne - 1
  ENDPROC && cellule_coord_alpha_vers_num
  
  PROCEDURE cellule_coord_num_vers_alpha( lnligne AS Number, lncol AS Number)
    * lnligne et lncol commence  0 (et non 1)
    * dans OO.Calc, une cellule peut tre accde par deux types de coordonnes quivalentes :
    * le texte "A1" ou "AA5" ou par ses numros de ligne/ numros de colonne.
    * "A1" quivaut  0,0
    IF PCOUNT()=2
      This.coord_cellule(1)= m.lnligne
      This.coord_cellule(2)= m.lncol
    ENDIF && PCOUNT()=2
    LOCAL lnli, lnco, lnaccu, lcresult
    lcresult = ""
    lnco = This.coord_cellule(2)
    DO CASE
    CASE m.lnco >= 702
      * le rsultat a 3 lettres
      lnaccu = INT(m.lnco / 702)
      lcresult = m.lcresult + CHR(64+ m.lnaccu)
      lnco = m.lnco - m.lnaccu*702
      lnaccu = INT(m.lnco / 26)
      lcresult = m.lcresult + CHR(65+ m.lnaccu)
      lnco = m.lnco - m.lnaccu*26
      lcresult = m.lcresult + CHR(65+m.lnco)
    CASE m.lnco >= 26
      lnaccu = INT(m.lnco / 26)
      lcresult = m.lcresult + CHR(64+ m.lnaccu)
      lnco = m.lnco - m.lnaccu*26
      lcresult = m.lcresult + CHR(65+m.lnco)
    CASE m.lnco >= 0
      lcresult = m.lcresult + CHR(65+m.lnco)
    ENDCASE
    * maintenant que l'on a les lettres, on fait les chiffres, c'est plus simple
    This.coord_cellule_alpha = m.lcresult+ ALLTRIM(STR(This.coord_cellule(1)+1,6))
  ENDPROC && cellule_coord_num_vers_alpha
  
  PROCEDURE texte_dans_cellule( pctext AS String, pnligne AS Number, pncol AS Number)
    * si on ne transmet qu'un seul paramtre, on travaille sur la cellule courante
    IF PCOUNT()=3
      This.coord_cellule(1)= m.pnligne
      This.coord_cellule(2)= m.pncol
    ENDIF && PCOUNT()=3
    This.une_cellule_texte = m.pctext
    * attention, dans getCellPosition le 1ere paramtre est la colonne, le 2me la ligne
    *This.feuille_active.getCellByPosition( This.coord_cellule(2), This.coord_cellule(1)).setString( m.pctext )
    This.une_cellule = This.feuille_active.getCellByPosition( This.coord_cellule(2), This.coord_cellule(1))
    This.une_cellule.setString( m.pctext )
  ENDPROC && texte_dans_cellule
  
  PROCEDURE valeur_dans_cellule( pnvaleur AS Number, pnligne AS Number, pncol AS Number)
    * si on ne transmet qu'un seul paramtre, on travaille sur la cellule courante
    IF PCOUNT()=3
      This.coord_cellule(1)= m.pnligne
      This.coord_cellule(2)= m.pncol
    ENDIF && PCOUNT()=3
    This.une_cellule_valeur = m.pnvaleur
    * attention, dans getCellPosition le 1ere paramtre est la colonne, le 2me la ligne
    *This.feuille_active.getCellByPosition( This.coord_cellule(2), This.coord_cellule(1)).setValue( m.pnvaleur )
    This.une_cellule = This.feuille_active.getCellByPosition( This.coord_cellule(2), This.coord_cellule(1))
    This.une_cellule.setValue( m.pnvaleur )
  ENDPROC && valeur_dans_cellule
  
  PROCEDURE formule_dans_cellule( pctext AS String, pnligne AS Number, pncol AS Number)
    * si on ne transmet qu'un seul paramtre, on travaille sur la cellule courante
    IF PCOUNT()=3
      This.coord_cellule(1)= m.pnligne
      This.coord_cellule(2)= m.pncol
    ENDIF && PCOUNT()=3
    * attention, dans getCellPosition le 1ere paramtre est la colonne, le 2me la ligne
    This.une_cellule_formule = m.pctext
    *This.feuille_active.getCellByPosition( This.coord_cellule(2), This.coord_cellule(1)).setFormula( m.pctext )
    This.une_cellule = This.feuille_active.getCellByPosition( This.coord_cellule(2), This.coord_cellule(1))
    This.une_cellule.setFormula( m.pctext )
  ENDPROC && texte_dans_cellule
  
  PROCEDURE date_dans_cellule( pudate,  pnligne AS Number, pncol AS Number)
    * si on ne transmet qu'un seul paramtre, on travaille sur la cellule courante
    IF PCOUNT()=3
      This.coord_cellule(1)= m.pnligne
      This.coord_cellule(2)= m.pncol
    ENDIF && PCOUNT()=3
    * attention, dans getCellPosition le 1ere paramtre est la colonne, le 2me la ligne
    LOCAL lddate, lcaccu, loformat, lolocal, lnformatdate
    lcaccu = VARTYPE(m.pudate)
    IF m.lcaccu=="T"
      lddate = TTOD(m.pudate)
    ELSE
      IF m.lcaccu=="D"
        lddate = m.pudate
      ELSE
        lddate = DATE()
      ENDIF && m.lcaccu=="D"
    ENDIF && VARTYPE(m.pudate)=="T"
    This.une_cellule_date = m.lddate
    * on dtaille les calculs pour faciliter le set step on
    * DTOC ne convient pas car OO veut une date  l'amricaine ...
    *lcaccu = DTOC(m.lddate)
    lcaccu = TRANSFORM( MONTH(m.lddate), "@L 99")+"/"+ ;
     TRANSFORM( DAY(m.lddate), "@L 99")+"/"+ STR(YEAR(m.lddate),4)
    This.une_cellule = This.feuille_active.getCellByPosition( This.coord_cellule(2), This.coord_cellule(1))
    This.une_cellule.setFormula( m.lcaccu)
    * dans les quelques lignes ci-dessous, je recopie btement l'exemple; j'ai pas tout compris.
    loformat = This.doc.getNumberFormats()
    lolocal = This.OOoCreateStruct( "com.sun.star.lang.Locale" )
    * com.sun.star.util.NumberFormat.DATE = 2
    lnformatdate = loformat.getStandardFormat( 2, lolocal) && 2 = date
    This.une_cellule.NumberFormat = m.lnformatdate
  ENDPROC && date_dans_cellule
  
  PROCEDURE lire_une_cellule( pnligne AS Number, pncol AS Number)
    * lit le contenu d'une cellule
    * mais comment savoir le type de donne ? 
    *  si c'est une valeur numrique, string et formula contiennent le STR(valeur)!
    * si on ne transmet pas de paramtre, on travaille sur la cellule courante
    IF PCOUNT()=2
      This.coord_cellule(1)= m.pnligne
      This.coord_cellule(2)= m.pncol
      This.une_cellule = This.feuille_active.getCellByPosition( This.coord_cellule(2), This.coord_cellule(1))
    ENDIF && PCOUNT()=3

    This.une_cellule_valeur = This.une_cellule.value && valeur numrique de la cellule
    This.une_cellule_texte = This.une_cellule.string && texte contenu dans la cellule
    This.une_cellule_formule = This.une_cellule.formula && formule contenue dans la cellule
*!*    une_cellule_date = {}     && date contenue dans une cellule
    LOCAL lnaccu
    lnaccu = 0 && pour le set step on
  ENDPROC && lire_une_cellule
  
  
ENDDEFINE && vfp_oo_calc



* ATTENTION : NE METTRE AUCUN CODE EXECUTABLE APRES UN DEFINE CLASS


#IF .F.
contenu de l'example VFP trouv dans http://www.oooforum.org/forum/viewtopic.phtml?p=28389#28389

VfpOOoCalcExample()

PROCEDURE VfpOOoCalcExample()
   * Create a spreadsheet.
   LOCAL oDoc
   oDoc = OOoOpenURL( "private:factory/scalc" )
   
   * Get first sheet
   LOCAL oSheet
   oSheet = oDoc.getSheets().getByIndex( 0 )
   
   *-----
   * Put some sales figures onto the sheet.
   oSheet.getCellByPosition( 0, 0 ).setString( "Month" )
   oSheet.getCellByPosition( 1, 0 ).setString( "Sales" )
   oSheet.getCellByPosition( 2, 0 ).setString( "End Date" )
   
   oSheet.getCellByPosition( 0, 1 ).setString( "Jan" )
   oSheet.getCellByPosition( 0, 2 ).setString( "Feb" )
   oSheet.getCellByPosition( 0, 3 ).setString( "Mar" )
   oSheet.getCellByPosition( 0, 4 ).setString( "Apr" )
   oSheet.getCellByPosition( 0, 5 ).setString( "May" )
   oSheet.getCellByPosition( 0, 6 ).setString( "Jun" )
   oSheet.getCellByPosition( 0, 7 ).setString( "Jul" )
   oSheet.getCellByPosition( 0, 8 ).setString( "Aug" )
   oSheet.getCellByPosition( 0, 9 ).setString( "Sep" )
   oSheet.getCellByPosition( 0, 10 ).setString( "Oct" )
   oSheet.getCellByPosition( 0, 11 ).setString( "Nov" )
   oSheet.getCellByPosition( 0, 12 ).setString( "Dec" )
   
   oSheet.getCellByPosition( 1, 1 ).setValue( 3826.37 )
   oSheet.getCellByPosition( 1, 2 ).setValue( 3504.21 )
   oSheet.getCellByPosition( 1, 3 ).setValue( 2961.45 )
   oSheet.getCellByPosition( 1, 4 ).setValue( 2504.12 )
   oSheet.getCellByPosition( 1, 5 ).setValue( 2713.98 )
   oSheet.getCellByPosition( 1, 6 ).setValue( 2448.17 )
   oSheet.getCellByPosition( 1, 7 ).setValue( 1802.13 )
   oSheet.getCellByPosition( 1, 8 ).setValue( 2203.22 )
   oSheet.getCellByPosition( 1, 9 ).setValue( 1502.54 )
   oSheet.getCellByPosition( 1, 10 ).setValue( 1207.68 )
   oSheet.getCellByPosition( 1, 11 ).setValue( 1819.71 )
   oSheet.getCellByPosition( 1, 12 ).setValue( 986.03 )
   
   oSheet.getCellByPosition( 2, 1 ).setFormula( "=DATE(2004;01;31)" )
   oSheet.getCellByPosition( 2, 2 ).setFormula( "=DATE(2004;02;29)" )
   oSheet.getCellByPosition( 2, 3 ).setFormula( "=DATE(2004;03;31)" )
   oSheet.getCellByPosition( 2, 4 ).setFormula( "=DATE(2004;04;30)" )
   oSheet.getCellByPosition( 2, 5 ).setFormula( "=DATE(2004;05;31)" )
   oSheet.getCellByPosition( 2, 6 ).setFormula( "=DATE(2004;06;30)" )
   oSheet.getCellByPosition( 2, 7 ).setFormula( "=DATE(2004;07;31)" )
   oSheet.getCellByPosition( 2, 8 ).setFormula( "=DATE(2004;08;31)" )
   oSheet.getCellByPosition( 2, 9 ).setFormula( "=DATE(2004;09;30)" )
   * Note that these last three dates are not set as DATE() function calls.
   oSheet.getCellByPosition( 2, 10 ).setFormula( "10/31/2004" )
   oSheet.getCellByPosition( 2, 11 ).setFormula( "11/30/2004" )
   oSheet.getCellRangeByName( "C13" ).setFormula( "12/31/2004" )
   *-----
   
   * Format the date cells as dates.   
   oFormats = oDoc.getNumberFormats()
   oLocale = OOoCreateStruct( "com.sun.star.lang.Locale" )
   * com.sun.star.util.NumberFormat.DATE = 2
   nDateKey = oFormats.getStandardFormat( 2, oLocale )
   oCell = oSheet.getCellRangeByName( "C2:C13" )
   oCell.NumberFormat = nDateKey
   
   LOCAL ARRAY aOneArg[1]
   LOCAL cFile, cURL
   
*   cFile = GetDesktopFolderPathname()+"example"
   cFile = "c:\example"

   * Now save the spreadsheet.
   cURL = OOoConvertToURL( cFile + ".sxw" )
   aOneArg[1] = OOoMakePropertyValue( "Overwrite", .T. )
   oDoc.storeToUrl( cURL, @ aOneArg )
   
   * Now save it as Excel
   cURL = OOoConvertToURL( cFile + ".xls" )
   aOneArg[1] = OOoMakePropertyValue( "FilterName", "MS Excel 97" )
   oDoc.storeToUrl( cURL, @ aOneArg )
   
   * Close the document.
*   oDoc.close( 1 ) && TRUE
ENDPROC





* Open or Create a document from it's URL.
* New documents are created by URL's such as:
*   private:factory/sdraw
*   private:factory/swriter
*   private:factory/scalc
*   private:factory/simpress
FUNCTION OOoOpenURL( cURL )
*   LOCAL oPropertyValue
*   oPropertyValue = OOoCreateStruct( "com.sun.star.beans.PropertyValue" )

*   LOCAL ARRAY aNoArgs[1]
*   aNoArgs[1] = oPropertyValue
*   aNoArgs[1].Name = "ReadOnly"
*   aNoArgs[1].Value = .F.

   * These two lines replace the alternate version above,
   *  which are left commented for the insight they provide.
   LOCAL ARRAY aNoArgs[1]
   aNoArgs[1] = OOoMakePropertyValue( "Hidden", .F. )
   
   LOCAL oDesktop
   oDesktop = OOoGetDesktop()

   LOCAL oDoc
   oDoc = oDesktop.LoadComponentFromUrl( cURL, "_blank", 0, @ aNoargs )
   
   * Make sure that arrays passed to this document are passed zero based.
   COMARRAY( oDoc, 10 )
   
   RETURN oDoc
ENDFUNC

* Create a com.sun.star.beans.PropertyValue struct and return it.
FUNCTION OOoMakePropertyValue( cName, uValue, nHandle, nState )
   LOCAL oPropertyValue
   oPropertyValue = OOoCreateStruct( "com.sun.star.beans.PropertyValue" )
   
   oPropertyValue.Name = cName
   oPropertyValue.Value = uValue
   
   IF TYPE([nHandle])="N"
      oPropertyValue.Handle = nHandle
   ENDIF
   IF TYPE([nState])="N"
      oPropertyValue.State = nState
   ENDIF
   
   RETURN oPropertyValue
ENDFUNC



* Sugar coated routine to create any UNO struct.
* Use the Bridge_GetStruct() feature of the OLE-UNO bridge.
FUNCTION OOoCreateStruct( cTypeName )
   LOCAL oServiceManager
   oServiceManager = OOoGetServiceManager()
   
   LOCAL oStruct
   oStruct = .NULL.

   LOCAL cOldErrHandler
   cOldErrHandler = ON( "ERROR" )
   ON ERROR = DoNothing__ErrorHandler( ERROR(), MESSAGE(), LINENO(), SYS(16), PROGRAM(), SYS(2018) )
      oStruct = oServiceManager.Bridge_GetStruct( cTypeName )
   ON ERROR &cOldErrHandler
   
   IF ISNULL( oStruct )
      =__OOoReleaseCachedVars()
      oServiceManager = OOoGetServiceManager()
      oStruct = oServiceManager.Bridge_GetStruct( cTypeName )
   ENDIF

   RETURN oStruct
ENDFUNC


* Return the OpenOffice.org desktop object.
* Cache it in a global variable.
* Create it if not already cached.
FUNCTION OOoGetDesktop()
   IF (TYPE([goOOoDesktop])!="O")  OR  ISNULL( goOOoDesktop )
      PUBLIC goOOoDesktop
      goOOoDesktop = OOoServiceManager_CreateInstance( "com.sun.star.frame.Desktop" )
      COMARRAY( goOOoDesktop, 10 )
   ENDIF
   RETURN goOOoDesktop
ENDFUNC



* Return the OpenOffice.org service manager object.
* Cache it in a global variable.
* Create it if not already cached.
FUNCTION OOoGetServiceManager()
   IF (TYPE([goOOoServiceManager])!="O")  OR  ISNULL( goOOoServiceManager )
      PUBLIC goOOoServiceManager
      goOOoServiceManager = CREATEOBJECT( "com.sun.star.ServiceManager" )
   ENDIF
   RETURN goOOoServiceManager
ENDFUNC


* Sugar coated routine to ask the service manager to
*  create you an instance of some other OpenOffice.org UNO object.
FUNCTION OOoServiceManager_CreateInstance( cServiceName )
   LOCAL oServiceManager
   oServiceManager = OOoGetServiceManager()
   
   LOCAL oInstance
   oInstance = .NULL.

   LOCAL cOldErrHandler
   cOldErrHandler = ON( "ERROR" )
   ON ERROR = DoNothing__ErrorHandler( ERROR(), MESSAGE(), LINENO(), SYS(16), PROGRAM(), SYS(2018) )
      oInstance = oServiceManager.createInstance( cServiceName )
   ON ERROR &cOldErrHandler
   
   IF ISNULL( oInstance )
      =__OOoReleaseCachedVars()
      oServiceManager = OOoGetServiceManager()
      oInstance = oServiceManager.createInstance( cServiceName )
   ENDIF

   RETURN oInstance
ENDFUNC


PROCEDURE DoNothing__ErrorHandler( pnError, pcErrMessage, pnLineNo, pcProgramFileSys16, pcProgram, pcErrorParamSys2018 )
ENDPROC


PROCEDURE __OOoReleaseCachedVars()
   RELEASE goOOoServiceManager, goOOoDesktop, goOOoCoreReflection
ENDPROC


* Convert a local filename to an OOo URL.
FUNCTION OOoConvertToURL( cFilename )
   * Ensure leading slash.
   IF LEFT( cFilename, 1 ) != "/"
      cFileName = "/" + cFileName
   ENDIF
   
   LOCAL cURL
   cURL = CHRTRAN( cFilename, "\", "/" )   && change backslashes to forward slashes.
   cURL = "file://" + cURL
   RETURN cURL
ENDFUNC

#ENDIF